"""
Autor: Matěj Vohradský (vohry8@students.zcu.cz)
Datum: 2023-10-16
Program: Program najde a vypise prirozene cislo s nejvetsim poctem delitelu v rozsahu <1,"zadana hodnota")
Verze: 1.0.0
"""

if __name__ == '__main__':
    # zakladni hodnota
    DEFAULT_RANGE = 1000
    # rozsah po ktery hleda cislo
    my_range = -1
    # vysledek
    result = [1]
    # pocet delitelu vysledku
    dividers = 1
    # pocet delitelu aktualniho cisla
    current_dividers = 2

    # vyzadani a zpracovani vstupu----------------------------------------------------------------------
    my_input = input("Zadej prirozene cislo (nebo nech prazdne pro zakladni hodnotu 1000):\n>")
    # kontroluje jestli je my_input prazdny, jestli ano tak zada zakladni hodnotu
    if my_input == "":
        my_range = DEFAULT_RANGE
    # kotroluje jestli je my_input prirozene cislo pokud ne tak program ukonci
    elif not my_input.isdecimal() or int(my_input) == 0:
        input("\nZadana hodnota neni prirozene cislo\nProgram skonci stiskem ENTER")
        exit(1)
    else:
        my_range = int(my_input)

    # hledani vysledku--------------------------------------------------------------------------------
    # prochazi vsechny cisla od 2 do zadaneho rozsahu
    for x in range(2, my_range + 1):
        # prochazi vsechny mozne delitele od 2 do poloviny prave testovaneho cisla
        for y in range(2, int(x / 2) + 1):
            if x % y == 0:
                current_dividers += 1
        # pokud bude pocet delitelu aktualniho cisla vetsi nez pocet delitelu vysledku tak je prepise
        if current_dividers > dividers:
            result = [x]
            dividers = current_dividers
        # pokud bude pocet delitelu aktualniho cisla stejny jako pocet delitelu vysledku tak je prida do vysledku
        elif current_dividers == dividers:
            result.append(x)
        current_dividers = 2

    # vytvoreni odpovedi------------------------------------------------------------------
    string = "Z cisel do " + str(my_range) + " ma nejvice prirozenych delitelu cisl"
    # vytvori jinou odpoved podle poctu vysledku
    if len(result) > 1:
        string += "a: "
        for x in result:
            string += str(x) + ", "
        string = string.removesuffix(", ")
    else:
        string += "o: " + str(result[0])
    input("\n" + string + "\nProgram skonci stiskem ENTER")
