"""
Description: Vypis n-teho sudeho cisla fibonacciho posloupnosti.
Author: Vaclav Ovsik, ovsikv@students.zcu.cz
Version: 2.0
Date: 18.10.2023
"""


def even_fib(n):
    """Rekurzivni metoda pro vypocet n-teho sudeho prvku."""

    if n == 0:
        # zastavovaci podminka pokud je n == 0
        return n

    if n == 1:
        # zastavovaci podminka pokud je n == 1
        return 2

    # rekurzivne vola funkci even_fib() se snizenym parametrem n
    return (4 * even_fib(n - 1)) + even_fib(n - 2)


print("Vypis n-teho sudeho cisla fibonacciho posloupnosti.")

try:
    n = int(input("Zadejte n: \n"))
    if n <= 0:
        # osetreni vstupu pro nekladne n
        print("Nelze zadat nekladne cislo!")
    else:
        print(str(n) + ". sude cislo je: " + str(even_fib(n)))  # vypis vysledku a volani metody even_fib()

# osetreni vstupu pomoci odchyceni vyjimky nezadani celeho cisla
except ValueError:
    print("Zadejte prirozene cislo!")

input("Konec_vypoctu")

