import typing


# autor: Miroslav Mart??nek


class Person:
    def __init__(self, name: str):
        self.name = name


class Relationship:
    def __init__(self, person1: Person, person2: Person, meaning: str):
        self.person1: Person = person1
        self.person2: Person = person2
        self.meaning: str = meaning


def print_relationship(person1: Person, person2: Person, relations: list[Relationship]):
    answer = "nejsou ve vz??jemn??m vstahu"
    for rel in relations:
        if (rel.person1 == person1 and rel.person2 == person2):
            answer = rel.meaning
    print(person1.name + " a " + person2.name + ": " + answer)


# Press the green button in the gutter to run the script.
if __name__ == '__main__':
    # definov??n?? vstah?? a lid??
    men = [Person("Petr"), Person("Jakub"), Person("Adam"), Person("Jid????"), Person("Alfons")]
    women = [Person("Kl??ra"), Person("Milana"), Person("Eli??ka"), Person("Jara"), Person("Brunhilda")]
    relationships = [Relationship(men[0], women[0], "rozveden??"),
                     Relationship(men[0], women[1], "man??el??"),
                     Relationship(men[1], women[2], "man??el??"),
                     Relationship(men[1], women[0], "milenci"),
                     Relationship(men[3], women[3], "ovdov??n??")
                     ]

    # p????klad pou??it?? metody
    print_relationship(men[0], women[1], relationships)
    print_relationship(men[4], women[1], relationships)

input('Skonči stiskem ENTER')
