"""
Author: Lukas Runt
Date: September 30, 2023,
Description: This program encodes text into code and decodes code into text.
"""
import sys
import encoder
import decoder


def chose_mode():
    """
    Method for choosing the mode
    E - Encoding from text to code
    D - Decoding from code to text
    Q - For quiting the application
    """
    print("Press E for encoding")
    print("Press D for decoding")
    print("Press Q for quit")
    user_input = input("Chose functionality: ")
    if user_input == 'E':
        encoder.start_encoding()
    elif user_input == 'D':
        decoder.start_decoding()
    elif user_input == 'Q':
        sys.exit()
    else:
        print("Invalid input!")


if __name__ == '__main__':
    while True:
        chose_mode()

input('Skonči stiskem ENTER')

