"""
@author Vitaliy Bohera
@version 1
@info Implementace algoritmu pro reseni hanojskych vezi
s danem poctem kotoucu
"""


''' Funkce vypisuje postup reseni hanojske veze
@param n - pocet kotoucu
@param start - pocatecni kolik na kterem jsou vsechny kotouce
@param cil - cilovy kolik kam mame presunout vsechny kotouce
@ param pom - treti pomocny kolik
'''
def hanoi(n, start, cil, pom):
    if n == 1:      # zastavovaci podminka rakurze pro pripad kdy mame jenom jeden kotouc
        print("Přesuň kotouč 1 z koliku", start, "na", cil)
        return

    hanoi(n - 1, start, pom, cil)       # rozdelime ulohu, ze budeme nejdriv presouvat n-1 kotoucu na pomocny kolik
    print("Přesuň kotouč", n, "z koliku", start, "na", cil)
    hanoi(n - 1, pom, cil, start)       # ted presouvame tech n-1 kotoucu z pomocneho koliku na cilovy


# funkce se zepta uzivatele na pocet kotoucu a na nazev 3 koliku
def main():

    while True:
        try:
            n = int(input("Zadej počet kotoučů (max 64): "))
        except ValueError:
            print("Vstupem musí být číslo!!!")
            continue

        if 64 >= n >= 1:
            break
        print("Číslo musí být v rozmezi 1 až 64!!!\n")

    print("\nZadej pořádí kolíků ve tvaru: [počátečný cílovyý pomocný]")
    print("Příklad: A C B ")

    while True:
        zprava = input("> ")
        koliky = zprava.split()
        if len(koliky) == 3:
            break
        print("Zadej 3 názvy kolíků oddělené mezerou: ")

    hanoi(n, koliky[0], koliky[1], koliky[2])


if __name__ == '__main__':
    main()


